#!/bin/bash
#
#
# 	Script d'initialisation d'un dépot vMap versionné sous git
#	Initislise l'ensemble des dépendances sous forme de subtrees
#
#
#


APP_NAME="vmap"

# Récupère la liste des dépendances
. ./get_deps.sh

cd ..

# Vitis
echo "---- Pull vitis ----"
git subtree pull --prefix src/vitis --squash -m "pull subtree"  "git@gitlab.veremes.net:Development/vitis_apps/sources/vitis.git" master

# fichiers à ignorer
git update-index --assume-unchanged conf/properties.json
git update-index --assume-unchanged conf/package.json
git update-index --assume-unchanged src/vitis/vas/rest/.htaccess
git update-index --assume-unchanged src/vitis/vas/rest/conf/properties.inc
git update-index --assume-unchanged src/vitis/vas/rest/conf/properties_domain.inc
git update-index --assume-unchanged src/vitis/vas/rest/conf/properties_post.inc
git update-index --assume-unchanged src/vitis/vas/rest/conf/properties_server.inc
git update-index --assume-unchanged src/vitis/vas/rest/conf/version.inc

# Modules
if [[ $depsCount > 0 ]]; then
	for (( i=1; i <= $depsCount; i++ )); do
		if [ ${aDeps[$i, nature]} == "modules" ]; then
			echo "---- Pull ${aDeps[$i, name]} ----"

			# Ajoute le dépôt
			git subtree pull --prefix src/${aDeps[$i, name]} --squash -m "pull subtree" "git@gitlab.veremes.net:Development/vitis_apps/sources/${aDeps[$i, name]}.git" master
			# fichiers à ignorer
			git update-index --assume-unchanged src/${aDeps[$i, name]}/web_service/conf/properties.inc
			git update-index --assume-unchanged src/${aDeps[$i, name]}/web_service/conf/properties_server.inc
			git update-index --assume-unchanged src/${aDeps[$i, name]}/web_service/conf/version.inc
		fi
	done
fi
