#!/bin/bash
#
#	Récupère l'ensemble des dépendances depuis conf/_install/dependency.xml
#
#
#
#

if [ "../conf/_install/dependency.xml" ]; then

	declare -A aDeps
	vitisVersion=master
	depsCount=0
	dependencies=($(cat "../conf/_install/dependency.xml" | tr -d '\040\011\012\015' | grep -oP '<dependency>([\s\S]*?)<\/dependency>'))

	for i in ${!dependencies[*]}; do

		sName=$(grep -oP '(?<=name>)[^<]+' <<< ${dependencies[$i]})
		sVersion=$(grep -oP '(?<=version>)[^<]+' <<< ${dependencies[$i]})
		sNature=$(grep -oP '(?<=nature>)[^<]+' <<< ${dependencies[$i]})

		if [ $sName == "vitis" ]; then
			vitisVersion=$sVersion
		fi
		if [ $sNature == "modules" ] || [ $sNature == "web_services" ] || [ $sName == "vitis" ]; then
			aDeps[$i, name]=$sName
			aDeps[$i, version]=$sVersion
			aDeps[$i, nature]=$sNature
			let depsCount++
		fi

	done

	echo "[INFO] dependencies:"
	echo "vitis : $vitisVersion"
	for i in ${!dependencies[*]}; do
		echo "(${aDeps[$i, nature]}) ${aDeps[$i, name]} : ${aDeps[$i, version]}"
	done
	echo "depsCount : ${depsCount}"

	export vitisVersion
	export depsCount
	export aDeps

else
	echo "[ERROR] ../conf/_install/dependency.xml not found"
fi
